<?php

class Presupuesto extends AppObjeto {

	const TARIFA_DEFECTO_PRECIO = 'TARIDISPO8';
	const CONCEPTO_DEFECTO_PRECIO = 4;
	const USUARIO_KARVE_DEFECTO = 'WW';
	const OFICINA_DEFECTO = 'C1';
	const TRATADO_SI = 1;
	const TRATADO_NO = 0;
	const RESPUESTA_ACEPTADA = 1;
	const RESPUESTA_PENDIENTE = 0;
	const RESPUESTA_DENEGADA = 2;
	const SUFIJO_COMERCIAL_PARA_PADRE = '000';
	
	// Propiedades 
	
	protected $numeroPresupuesto;
	protected $localizador;
	protected $fechaInicio;
	protected $horaInicio;
	protected $origenLugar;
	protected $origenCalle;
	protected $origenNumero;
	protected $origenCP;
	protected $origenPoblacion;
	protected $origenPais;
	protected $fechaFin;
	protected $horaFin;
	protected $destinoLugar;
	protected $destinoCalle;
	protected $destinoNumero;
	protected $destinoCP;
	protected $destinoPoblacion;
	protected $destinoPais;
	protected $codigoVehiculo;
	protected $codigoTipoServicio;
	protected $tipoServicio;
	protected $vehiculoMarca;
	protected $vehiculoModelo;
	protected $vehiculoGrupo;
	protected $vehiculoProveedor;
	protected $observaciones;
	protected $itinerario;
	protected $origenPresupuesto;
	protected $baseImponible;
	protected $iva;
	protected $totalConIva;
	protected $nombreCliente;
	protected $telefonoCliente;
	protected $codigoPotencial;
	protected $aceptada;
	protected $tratado;
	protected $tratadoUsuario;
	protected $tratadoFecha;
	protected $fecha_aceptada;
	protected $motivo;
	protected $gpsSalida;
	protected $gpsRetorno;
	protected $codigoReserva;
	protected $codigoServicio;
	protected $codigoCliente;
	protected $intentoTpv;
	protected $archivoRuta;
	protected $kmsRuta;
	protected $tiempoRuta;
	
	protected $comercial;
	protected $comisionista1;
	protected $comisionista2;
	
	protected $fechaCreada;
	protected $esConChofer;
	protected $sublicen;
	protected $medioRecepcion;
	protected $usuarioKarve;
	
	protected $oficina;
	protected $oficinaSalida;
	protected $oficinaRetorno;
	protected $usuarioUltimaModificacion;
	protected $fechaUltimaModificacion;
	protected $contactoNombre;
	protected $contactoTelefono;
	protected $numeroPersonas;
	
	// propiedades calculadas
	protected $fecha_hora_inicio;
	protected $direccion_origen;
	protected $direccion_destino;
	protected $direccion_origen_proveedor;
	protected $direccion_destino_proveedor;
	protected $nombreVehiculo;
	protected $destinoPaisTexto;
	protected $origenPaisTexto;
	
	
	// Conectar con bbdd

	protected static $_aliasTabla = 'p1';
	protected static $_nombreTabla = 'PRESUP1';
	protected static $_campoPK = 'NUMERO_PRE';
	protected static $_tipo_primary = self::APP_TIPO_PRIMARY_STRING;
	

	// initmetadatos
	protected static function initMetaDatos(){

		self::addPropiedadBD('p1', 'NUMERO_PRE', 'numeroPresupuesto', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'FSALIDA_PRE1', 'fechaInicio', self::META_DATE);
		self::addPropiedadBD('p1', 'HSALIDA_PRE1','horaInicio', self::META_TIME);
		self::addPropiedadBD('p1', 'ENT_CALLE', 'origenCalle', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ENT_NUM', 'origenNumero', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ENT_CP', 'origenCP', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ENT_POB', 'origenPoblacion', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'PAISORIGEN_PRE1', 'origenPais', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'FPREV_PRE1','fechaFin', self::META_DATE);
		self::addPropiedadBD('p1', 'HPREV_PRE1','horaFin', self::META_TIME);
		self::addPropiedadBD('p1', 'ENT_CALLER', 'destinoCalle', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ENT_NUMR', 'destinoNumero', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ENT_CPR', 'destinoCP', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ENT_POBR', 'destinoPoblacion', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'PAISDESTINO_PRE1', 'destinoPais', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'LUENTRE_PRE1', 'origenLugar', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'LUDEVO_PRE1', 'destinoLugar', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'VCACT_PRE1', 'codigoVehiculo', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'NOTAS_PRE1', 'itinerario', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ACEPTADA', 'aceptada', self::META_INT);
		self::addPropiedadBD('p1', 'TRATADO', 'tratado', self::META_INT);
		self::addPropiedadBD('p1', 'USU_TRATADO', 'tratadoUsuario', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'FECHA_TRATADO', 'tratadoFecha', self::META_DATE);
		self::addPropiedadBD('p1', 'FECHA_ACEP', 'fecha_aceptada', self::META_DATE);
		self::addPropiedadBD('p1', 'MOPETI', 'motivo', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'CONTACTO_PRE1', 'codigoPotencial', self::META_INT);
		self::addPropiedadBD('p1', 'COORDGPS_SAL', 'gpsSalida', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'COORDGPS_RET', 'gpsRetorno', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'TARIFA_PRE1', 'codigoTipoServicio', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'GRUPO_PRE1', 'vehiculoGrupo', self::META_VARCHAR);		
		self::addPropiedadBD('p1', 'PROVEEDOR', 'vehiculoProveedor', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'RESERVA_PRE1', 'codigoReserva', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'CONTRATO_PRE1', 'codigoServicio', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'CLIENTE_PRE1', 'codigoCliente', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'INTENTO_TPV', 'intentoTpv', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ARCHIVO_RUTA', 'archivoRuta', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'KMS_RUTA', 'kmsRuta', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'TIEMPO_RUTA', 'tiempoRuta', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'LOCALIZA_PRE1', 'localizador', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'FECHA_PRE1', 'fechaCreada', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ESCONCHOFER_PRE1', 'esConChofer', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'SUBLICEN_PRE1', 'sublicen', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'MEDIO_PRE1', 'medioRecepcion', self::META_INT);
		self::addPropiedadBD('p1', 'RENTAL1_PRE1', 'usuarioKarve', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'OFICINA_PRE1', 'oficina', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'OFISALIDA_PRE1', 'oficinaSalida', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'OFIRETORNO_PRE1', 'oficinaRetorno', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'USUARIO_PRE1', 'usuarioUltimaModificacion', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'ULTMODI_PRE1', 'fechaUltimaModificacion', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'PERSONA_PRE1', 'contactoNombre', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'TELFPERS_PRE1', 'contactoTelefono', self::META_VARCHAR);
		self::addPropiedadBD('p1', 'NPERSONAS_PRE1', 'numeroPersonas', self::META_VARCHAR);
		
				
		self::addTablaRelacion('NTARI', 'NTARI', 'CODIGO', 'p1', 'TARIFA_PRE1', false);
		self::addPropiedadBD('NTARI', 'NOMBRE', 'tipoServicio', self::META_VARCHAR);
		
		self::addTablaRelacion('VEHICULO1', 'VEHICULO1', 'CODIINT', 'p1', 'VCACT_PRE1');		
		self::addPropiedadBD('VEHICULO1', 'MARCA', 'vehiculoMarca', self::META_VARCHAR);
		self::addPropiedadBD('VEHICULO1', 'MODELO', 'vehiculoModelo', self::META_VARCHAR);

		self::addTablaRelacion('PRESUP2', 'PRESUP2', 'NUMERO_PRE', 'p1', 'NUMERO_PRE', true);
		self::addPropiedadBD('PRESUP2', 'OBS1_PRE2', 'observaciones', self::META_VARCHAR);
		self::addPropiedadBD('PRESUP2', 'ORIGEN_PRE2', 'origenPresupuesto', self::META_INT);
		self::addPropiedadBD('PRESUP2', 'TOLON_PRE2', 'totalConIva', self::META_DECIMAL);
		self::addPropiedadBD('PRESUP2', 'BASEI_PRE2', 'baseImponible', self::META_DECIMAL);
		self::addPropiedadBD('PRESUP2', 'IVA_PRE2', 'iva', self::META_DECIMAL);
		self::addPropiedadBD('PRESUP2', 'COMICLAVE_PRE2', 'comercial', self::META_VARCHAR);
		self::addPropiedadBD('PRESUP2', 'COMISIO_PRE2', 'comisionista1', self::META_VARCHAR);
		self::addPropiedadBD('PRESUP2', 'COMISIO2_PRE2', 'comisionista2', self::META_VARCHAR);

		self::addTablaRelacion('POTENCIALES', 'POTENCIALES', 'NUMERO', 'p1', 'CONTACTO_PRE1');
		self::addPropiedadBD('POTENCIALES', 'NOMBRE', 'nombreCliente', self::META_VARCHAR);
		self::addPropiedadBD('POTENCIALES', 'TELEFONO', 'telefonoCliente', self::META_VARCHAR);
		
		self::addTablaRelacion('Pais', 'pais', 'siglas', 'p1', 'PAISORIGEN_PRE1');
		self::addPropiedadBD('Pais', 'pais', 'destinoPaisTexto', self::META_VARCHAR);

		self::addTablaRelacion('Pais2', 'pais', 'siglas', 'p1', 'PAISDESTINO_PRE1');
		self::addPropiedadBD('Pais', 'pais', 'origenPaisTexto', self::META_VARCHAR);
		
	}

	// Funciones
	
	
	public function load($id){
		parent::load($id);
		if($this->id){	
			$this->nombreVehiculo = $this->vehiculoMarca.' '.$this->vehiculoModelo;
			$this->fecha_hora_inicio = $this->fechaInicio.' '. $this->horaInicio;
			$this->direccion_origen = $this->origenCalle. ' '.$this->origenNumero.' '.$this->origenCP .' '. $this->origenPoblacion;
			$this->direccion_destino = $this->destinoCalle.' '.$this->destinoNumero	.' '.$this->destinoCP .' '.$this->destinoPoblacion;
			$this->direccion_origen_proveedor = $this->origenCalle. ' '.$this->origenCP .' '. $this->origenPoblacion;
			$this->direccion_destino_proveedor = $this->destinoCalle.' '.$this->destinoCP .' '.$this->destinoPoblacion;
			$this->baseImponible = round($this->baseImponible,2);
			$this->iva = round($this->iva, 2);
			$this->totalConIva = round($this->totalConIva, 2);
			$this->origenPresupuesto = round($this->origenPresupuesto,0);
		}
	}
	
	/*
	select p1.numero_pre as codigo, p1.fsalida_pre1 as fechaInicio, p1.hsalida_pre1 as horaInicio,
	p1.ent_pob as poblacion, v1.marca, v1.modelo, p1.persona_pre1, p1.telfpers_pre1, p1.npersonas_pre1
	from presup1 as p1
	inner join presup2 as p2 on p1.numero_pre=p2.numero_pre
	inner join potenciales as pot on pot.numero = p1.contacto_pre1
	inner join vehiculo1 as v1 on p1.vcact_pre1=v1.codiint
	where p2.comiclave_pre2 = '0588001'
	and p1.numero_pre like '00%'
	and p1.aceptada = 0
	*/
	
	public static function lst_activos($params){
		$potencialComercial = Usuario::getPotencialLogueado();
		$select = self::selectObjeto();
		// Presupuestos cuyo codiclave es el comercial
		$select->where("PRESUP2.comiclave_pre2=?",$potencialComercial->getCodigoComisionista());
		// Presupuestos cuyo codigo empieza por 00 codigo de la empresa
		$select->where("p1.numero_pre like ?",Constantes::NUMERO_EMPRESA.'%');
		// presupuestos pendientes de respuesta por el cliente
		$select->where("p1.aceptada=?",Presupuesto::RESPUESTA_PENDIENTE);
		
		$res = self::selectExecute($select,$params);
		$datos = $res->getDatos();
		foreach ($datos as &$reg) {
			if ($reg['totalConIva']>0)
				$reg['totalConIva'] = number_format($reg['totalConIva'],2);
			else 
				$reg['totalConIva'] = '<i>En proceso</i>';
		}
		$res->setDatos($datos);
		return $res;
	} 
	
	
	public function save(){
		$esNuevo = true;
		if (!$this->numeroPresupuesto){
			$this->numeroPresupuesto = self::siguienteIdMaximo();
			$this->fechaCreada = date('Y-m-d');
			$this->esConChofer = 1;
			$this->sublicen = '00';
			$this->oficina = self::OFICINA_DEFECTO;
			$this->oficinaSalida = self::OFICINA_DEFECTO;
			$this->oficinaRetorno = self::OFICINA_DEFECTO;
			
		} else {
			$esNuevo = false;
		}
		$this->localizador = $this->numeroPresupuesto;
		$this->usuarioUltimaModificacion = self::USUARIO_KARVE_DEFECTO;
		$this->fechaUltimaModificacion = date('YmdH:i');
		
		$vehiculo = new Vehiculo($this->codigoVehiculo);
		$this->vehiculoGrupo = $vehiculo->getCategoria();

		$propietario = Potencial::getByPropietario($vehiculo->getPropietario()); 
		$this->vehiculoProveedor = $propietario->getProveedor();
		parent::save();
		if ($esNuevo){
			$this->insertarLineas();
		}
	}
/*
	public function setAfiliado($afiliado, $codigoOrigen){
		if ($afiliado){
			$numeroSub = substr($afiliado,4,3);
			$numero = substr($afiliado,0,4);
			if ($numeroSub!='000'){
				$this->comisionista = $numero.'000';
				$this->subcomisionista = $afiliado;
			} else {
				$this->comisionista = $numero.'000';
				$this->subcomisionista = '';
			}
		} elseif ($codigoOrigen>0) {
			$origenComisionista = new Origen($codigoOrigen);
			$comisionista = $origenComisionista->getComisionista();
			$this->comisionista = $comisionista;
			$this->subcomisionista = $comisionista;
		}
	}
	*/
	
	public function asignarComisionistas($codigoOrigen, $codigoAfiliacion){
		
		$escribir_pasos = false;
		
		$tieneComisionistaElOrigen = false;
		$comercial = '';
		$comisionista1 = '';
		$comisionista2 = '';
		
		$codigoPotencial = $this->getCodigoPotencial();
		$potencial = new Potencial($codigoPotencial);
		$comercial_potencial = $potencial->getComercial();
		$comercial_padre_potencial = $potencial->getComercialPadre();
		$potencial_comisionista = $potencial->getCodigoComisionista();
		
		$autocompra = false;
		if (($comercial_potencial>0) && ($comercial_potencial == $potencial_comisionista)) $autocompra = true;
		$origen = new Origen($codigoOrigen);
		$comisionista_origen = $origen->getCodigoComisionista();
		if ($escribir_pasos) echo 'POT: '.$codigoPotencial.' - COMI: '.$potencial_comisionista. ' - COMER: '.$comercial_potencial. ' - COMER PADRE: '.$comercial_padre_potencial.' Origen:'.$comisionista_origen.'<br>';
		if ($escribir_pasos) echo 'Afiliado: '.$codigoAfiliacion;
		if ($comisionista_origen > 0) $tieneComisionistaElOrigen = true;
		if ($codigoAfiliacion>0){
			$afiliacion = new Potencial($codigoAfiliacion);
			$comisionista_afiliado_hijo = $afiliacion->getCodigoComisionista();
			$comisionista_afiliado_padre = $afiliacion->getCodigoComisionistaPadre();
			
		}
		
		if ($escribir_pasos) echo '<b>PASO: ';
		if ($tieneComisionistaElOrigen){
			if ($escribir_pasos) echo 'Origen con comisionista - ';
			if ($codigoAfiliacion>0){
				if ($escribir_pasos) echo 'Afiliado ';
				if ($comisionista_afiliado_padre>0){
					if ($escribir_pasos) echo '2 comisionista - ';
				} else {
					if ($escribir_pasos) echo '1 comisionista - ';
				}
								
				if ($autocompra){
					if ($escribir_pasos) echo 'Autocompra - ';
					if ($comercial_padre_potencial >0){
						if ($escribir_pasos) echo 'Potencial 2 comisionistas - ';
						$comercial = $comercial_potencial;
						$comisionista1 = $comercial_padre_potencial;
						$comisionista2 = $comercial_potencial;
					} else {
						if ($escribir_pasos) echo 'Potencial 1 comisionista - ';
						$comercial = $comercial_potencial;
						$comisionista1 = $comercial_potencial;
						$comisionista2 = '';
					}
				} else {
					if (!$comercial_potencial){
						if ($escribir_pasos) echo 'Potencial sin comisionista ';
						$comercial = $comisionista_afiliado_hijo;
						$comisionista1 = $comisionista_origen;
						$comisionista2 = $comisionista_afiliado_hijo;
					} else {				
						if ($escribir_pasos) echo 'No autocompra - ';
						if ($comercial_padre_potencial >0){
							if ($escribir_pasos) echo 'Potencial 2 comisionistas - ';
							$comercial = $comisionista_afiliado_hijo;
							$comisionista1 = $comisionista_origen;
							$comisionista2 = $comisionista_afiliado_hijo;
						} else {
							if ($escribir_pasos) echo 'Potencial 1 comisionista - ';
							$comercial = $comisionista_afiliado_hijo;
							$comisionista1 = $comisionista_origen;
							$comisionista2 = $comisionista_afiliado_hijo;
						}
					}
				}
			} else {
				if ($escribir_pasos) echo 'No afiliado - ';
				if ($autocompra){
					if ($escribir_pasos) echo 'Autocompra - ';
					if ($comercial_padre_potencial >0){
						if ($escribir_pasos) echo 'Potencial 2 comisionistas - ';
						$comercial = $comercial_potencial;
						$comisionista1 = $comercial_padre_potencial;
						$comisionista2 = $comercial_potencial;
					} else {
						if ($escribir_pasos) echo 'Potencial 1 comisionista - ';
						$comercial = $comercial_potencial;
						$comisionista1 = $comercial_potencial;
						$comisionista2 = '';
					}
				} else {
					if (!$comercial_potencial){
						if ($escribir_pasos) echo 'Potencial sin comisionista';
						$comercial = $comisionista_origen;
						$comisionista1 = $comisionista_origen;
						$comisionista2 = '';
					}else {
						if ($escribir_pasos) echo 'No Autocompra - ';
						if ($comercial_padre_potencial >0){
							if ($escribir_pasos) echo 'Potencial 2 comisionistas - ';
							$comercial = $comisionista_origen;
							$comisionista1 = $comisionista_origen;
							$comisionista2 = '';
						} else {
							if ($escribir_pasos) echo 'Potencial 1 comisionista - ';
							$comercial = $comisionista_origen;
							$comisionista1 = $comisionista_origen;
							$comisionista2 = '';
						}
					}
				}
			}
		} else { 
			if ($escribir_pasos) echo 'Origen sin comisionista - ';
			if ($codigoAfiliacion>0){
				if ($escribir_pasos) echo ' Afiliado ';
				$afiliado_hijo = Potencial::getByCodigoComisionista($codigoAfiliacion);
				//$afiliado_hijo = new Potencial($codigoAfiliacion);
				$comisionista_afiliado_hijo = $afiliado_hijo->getCodigoComisionista();
				if ($escribir_pasos) echo 'Potencial Afiliado: '.$afiliado_hijo->getCodigo().' Comisionista Afiliado Hijo: '.$comisionista_afiliado_hijo;
				$comisionista_afiliado_padre = $afiliado_hijo->getCodigoComisionistaPadre();
				if ($comisionista_afiliado_padre >0){
					if ($escribir_pasos) echo ' 2 comisionistas - ';
					$comercial = $comisionista_afiliado_hijo;
					$comisionista1 = $comisionista_afiliado_padre;
					$comisionista2 = $comisionista_afiliado_hijo;
				} else {
					if ($escribir_pasos) echo ' 1 comisionista - ';
					$comercial = $comisionista_afiliado_hijo;
					$comisionista1 = $comisionista_afiliado_hijo;
					$comisionista2 = '';
				}
				
				/*
				if ($comisionista_afiliado_padre>0){
					if ($escribir_pasos) echo '2 comisionista - ';
				} else {
					if ($escribir_pasos) echo '1 comisionista - ';
				}
				if ($autocompra) {
					if ($escribir_pasos) echo 'Autocompra - ';
					if ($comercial_padre_potencial >0){
						if ($escribir_pasos) echo 'Potencial 2 comisionistas - ';
						$comercial = $comercial_potencial;
						$comisionista1 = $comercial_padre_potencial;
						$comisionista2 = $comercial_potencial;
					} else {
						if ($escribir_pasos) echo 'Potencial 1 comisionista - ';
						$comercial = $comercial_potencial;
						$comisionista1 = $comercial_potencial;
						$comisionista2 = '';
					}
				} else {
					if ($escribir_pasos) echo 'No autocompra - ';
					if ($comisionista_afiliado_padre >0){
						if ($escribir_pasos) echo ' 2 comisionistas - ';
						$comercial = $comisionista_afiliado_hijo;
						$comisionista1 = $comisionista_afiliado_padre;
						$comisionista2 = $comisionista_afiliado_hijo;
					} else {
						if ($escribir_pasos) echo ' 1 comisionista - ';
						$comercial = $comisionista_afiliado_hijo;
						$comisionista1 = $comisionista_afiliado_hijo;
						$comisionista2 = '';
					}
				}
				*/
			} else { // Sin afiliado
				if ($escribir_pasos) echo 'No Afiliado -';
				if ($autocompra) {
					if ($escribir_pasos) echo 'Autocompra - ';
					if ($comercial_potencial>0){
						if ($comercial_padre_potencial>0){
							if ($escribir_pasos) echo 'Dos comisionistas';
							$comercial = $comercial_potencial;
							$comisionista1 = $comercial_padre_potencial;
							$comisionista2 = $comercial_potencial;
						} else {
							if ($escribir_pasos) echo 'Un comisionista';
							$comercial = $comercial_potencial;
							$comisionista1 = $comercial_potencial;
							$comisionista2 = '';
						}
					} else {
						if ($escribir_pasos) echo 'Sin comisionista';
						$comercial = '';
						$comisionista1 = '';
						$comisionista2 = '';
					
					}
				} else {
					if ($escribir_pasos) echo 'No autocompra - ';
					if ($comercial_potencial>0){
						if ($comercial_padre_potencial>0){
							if ($escribir_pasos) echo 'Dos comisionistas';
							$comercial = $comercial_potencial;
							$comisionista1 = $comercial_padre_potencial;
							$comisionista2 = $comercial_potencial;
						} else {
							if ($escribir_pasos) echo 'Un comisionista';
							$comercial = $comercial_potencial;
							$comisionista1 = $comercial_potencial;
							$comisionista2 = '';
						}
					} else {
						if ($escribir_pasos) echo 'Sin comisionista';
						$comercial = '';
						$comisionista1 = '';
						$comisionista2 = '';
						
					}
				}
				
			} 
		}
		if ($escribir_pasos) echo '</b><br>';
		if ($escribir_pasos) echo 'COMISIONISTAS:<br>';
		if ($escribir_pasos) echo 'Comercial:'.$comercial.' / Comisionista1: '.$comisionista1.' / Comisionista2: '.$comisionista2;
		$this->setComercial($comercial);
		$this->setComisionista1($comisionista1);
		$this->setComisionista2($comisionista2);
	}
	
	public function getTipoServicio() {
	    return $this->tipoServicio;
	}
	public function setTipoServicio($tipoServicio) {
	    $this->tipoServicio = $tipoServicio;
	}
	
	public function getComercial() {
	    return $this->comercial;
	}
	public function setComercial($comercial) {
	    $this->comercial = $comercial;
	}
	
	public function getComisionista1() {
	    return $this->comisionista1;
	}
	public function setComisionista1($comisionista1) {
	    $this->comisionista1 = $comisionista1;
	}
	
	public function getComisionista2() {
	    return $this->comisionista2;
	}
	public function setComisionista2($comisionista2) {
	    $this->comisionista2 = $comisionista2;
	}
	
	private function insertarLineas(){
		$sql = "execute spRecalcPresu @NUMERO='".$this->numeroPresupuesto."',@TARIFA='".$this->getCodigoTipoServicio()."'  ,@GRUPO='".$this->vehiculoGrupo."'";
		try{
			$db = self::getDb();
			$adapter = $db->getAdapter();
			$adapter->query($sql);
		} catch (Exception $e){
			echo $e->getMessage();
		}
	}
	
	private static function siguienteIdMaximo(){
		$usuario = Usuario::UsuarioLoqueado();
		$db = self::getDb();
		$select = $db->select();
		$select->setIntegrityCheck(false);
		$select->from(array('r'=>'PRESUP1'),array('numero_max' => 'MAX(NUMERO_PRE)'));
		if (isset($usuario->EMPRESA))  {
			$empresa = $usuario->EMPRESA;
		}else {
			$empresa = '00';
		}
			
		$select->where("NUMERO_PRE like '".$empresa."%'");
		$resultado = $db->fetchRow($select);
		$num_max = $resultado->numero_max + 1;
		$num_max = str_repeat('0',10-strlen($num_max)).$num_max;
		return $num_max;
	}
	
	public function toReserva(){
		
		if (!$this->codigoReserva){
			$sql = "select cv.fnPresu_a_Reser('".$this->numeroPresupuesto."') as codigoReserva";
			try {
				$db = self::getDb();
				$adapter = $db->getAdapter();
				$stmt = $adapter->query($sql);
				$rows = $stmt->fetchAll();
				$codigoReserva = $rows[0]['codigoReserva'];
			} catch(Exception $e){
				die('Error ToReserva:'.$e->getMessage());
			}
			return $codigoReserva;
		} else {
			return $this->codigoReserva;
		}
	} 

	
	// GET Y SET
	
	public function getOrigenPais() {
	    return $this->origenPais;
	}
	public function setOrigenPais($origenPais) {
	    $this->origenPais = $origenPais;
	}
		
	public function getDestinoPais() {
	    return $this->destinoPais;
	}
	public function setDestinoPais($destinoPais) {
	    $this->destinoPais = $destinoPais;
	}
	
	public function getFechaAceptada() {
	    return $this->fecha_aceptada;
	}
	public function setFechaAceptada($fecha_aceptada) {
	    $this->fecha_aceptada = $fecha_aceptada;
	}
	
	public function getMotivoRechazo() {
	    return $this->motivo;
	}
	public function setMotivoRechazo($motivo) {
	    $this->motivo = $motivo;
	}
	
	public function getAceptada() {
	    return $this->aceptada;
	}
	
	public function setAceptado($aceptado) {
	    $this->aceptada = $aceptado;
	    if ($this->aceptada)
	    	$this->fecha_aceptada = date('d/m/Y');
	}
	
	public function setPagadoPresupuesto(){
		$this->motivo = '';
		// Ingresar el cobro
	}
	
	public function setMotivoAnulacion($motivo){
		$this->motivo = $motivo;
	}
	
	public function getTratado() {
	    return $this->tratado;
	}
	public function setTratado($tratado) {
	    $this->tratado = $tratado;
	    if ($tratado){
	    	$this->tratadoFecha = date('d/m/Y');
	    	$this->tratadoUsuario = self::USUARIO_KARVE_DEFECTO;
	    } else {
	    	$this->tratadoFecha = '';
	    	$this->tratadoUsuario = '';
	    }
	    
	}
	
	public function getCodigoVehiculo() {
	    return $this->codigoVehiculo;
	}
	public function setCodigoVehiculo($codigoVehiculo) {
	    $this->codigoVehiculo = $codigoVehiculo;
	}
	
	public function getCodigoTipoServicio() {
	    return $this->codigoTipoServicio;
	}
	public function setCodigoTipoServicio($codigoTipoServicio) {
	    $this->codigoTipoServicio = $codigoTipoServicio;
	}
	
	public function getCodigoPotencial() {
	    return $this->codigoPotencial;
	}
	public function setCodigoPotencial($codigoPotencial) {
	    $this->codigoPotencial = $codigoPotencial;
	}
	
	public function getNombreCliente() {
	    return $this->nombreCliente;
	}
	public function setNombreCliente($nombreCliente) {
	    $this->nombreCliente = $nombreCliente;
	}
	
	public function getBaseImponible() {
	    return $this->baseImponible;
	}
	public function setBaseImponible($baseImponible) {
	    $this->baseImponible = $baseImponible;
	}
	
	public function getIva() {
	    return $this->iva;
	}
	public function setIva($iva) {
	    $this->iva = $iva;
	}
	
	public function getTotalConIva() {
	    return $this->totalConIva;
	}
	public function setTotalConIva($totalConIva) {
	    $this->totalConIva = $totalConIva;
	}
	
	public function getFechaFin() {
	    return $this->fechaFin;
	}
	public function setFechaFin($fechaFin) {
	    $this->fechaFin = $fechaFin;
	}
	
	public function getHoraFin() {
	    return $this->horaFin;
	}
	public function setHoraFin($horaFin) {
	    $this->horaFin = $horaFin;
	}
	
		
	
	public function getNumeroPresupuesto() {
	    return $this->numeroPresupuesto;
	}
	public function setNumeroPresupuesto($numeroPresupuesto) {
	    $this->numeroPresupuesto = $numeroPresupuesto;
	}

	public function getpoblacion() {
	    return $this->poblacion;
	}
	public function setpoblacion($poblacion) {
	    $this->poblacion = $poblacion;
	}
	
	public function getProvincia() {
	    return $this->provincia;
	}
	public function setProvincia($provincia) {
	    $this->provincia = $provincia;
	}
	
	public function getOrigenDireccion() {
	    return $this->direccion_origen;
	}
	public function setOrigenDireccion($direccion_origen) {
	    $this->direccion_origen = $direccion_origen;
	}

	public function getDestinoDireccion() {
	    return $this->direccion_destino;
	}
	public function setDestinoDireccion($direccion_destino) {
	    $this->direccion_destino = $direccion_destino;
	}
	
	public function getOrigenLugar() {
	    return $this->origenLugar;
	}
	public function setOrigenLugar($origenLugar) {
	    $this->origenLugar = $origenLugar;
	}
	
	public function getDestinoLugar() {
	    return $this->destinoLugar;
	}
	public function setDestinoLugar($destinoLugar) {
	    $this->destinoLugar = $destinoLugar;
	}
	
	public function getFechaHoraInicio() {
	    return $this->fecha_hora_inicio;
	}
	public function setFechaHoraInicio($fecha_hora_inicio) {
	    $this->fecha_hora_inicio = $fecha_hora_inicio;
	}
	
	public function getVehiculoNombre() {
	    return $this->nombreVehiculo;
	}
	public function setVehiculoNombre($nombreVehiculo) {
	    $this->nombreVehiculo = $nombreVehiculo;
	}
	
	public function getObservaciones() {
	    return $this->observaciones;
	}
	public function setObservaciones($observaciones) {
	    $this->observaciones = $observaciones;
	}
	
	public function getNumeroPersonas() {
		return $this->numeroPersonas;
	}
	public function setNumeroPersonas($numeroPersonas) {
		$this->numeroPersonas = $numeroPersonas;
	}

	public function getOrigenCalle() {
		return $this->origenCalle;
	}
	public function setOrigenCalle($origenCalle) {
		$this->origenCalle = $origenCalle;
	}

	public function getDestinoCalle() {
		return $this->destinoCalle;
	}
	public function setDestinoCalle($destinoCalle) {
		$this->destinoCalle = $destinoCalle;
	}
	
	public function getOrigenNumero(){
		return $this->origenNumero;
	}
	
	public function setOrigenNumero($numero){
		$this->origenNumero = $numero;
	}
	
	public function getDestinoNumero() {
	    return $this->destinoNumero;
	}
	public function setDestinoNumero($destinoNumero) {
	    $this->destinoNumero = $destinoNumero;
	}
	
	public function getOrigenCodigoPostal(){
		return $this->origenCP;
	}
	public function setOrigenCodigoPostal($cp){
		$this->origenCP = $cp;
	}
	public function getDestinoCodigoPostal() {
	    return $this->destinoCP;
	}
	public function setDestinoCodigoPostal($destinoCP) {
	    $this->destinoCP = $destinoCP;
	}
	
	public function getOrigenPoblacion(){
		$this->origenPoblacion;
	}
	public function setOrigenPoblacion($poblacion){
		$this->origenPoblacion = $poblacion;
	}
	public function getDestinoPoblacion() {
	    return $this->destinoPoblacion;
	}
	public function setDestinoPoblacion($destinoPoblacion) {
	    $this->destinoPoblacion = $destinoPoblacion;
	}
	
	public function getOrigenDireccionProveedor() {
	    return $this->direccion_origen_proveedor;
	}
	public function setOrigenDireccionProveedor($direccion_origen_proveedor) {
	    $this->direccion_origen_proveedor = $direccion_origen_proveedor;
	}
	
	public function getDestinoDireccionProveedor() {
	    return $this->direccion_destino_proveedor;
	}
	public function setDestinoDireccionProveedor($direccion_destino_proveedor) {
	    $this->direccion_destino_proveedor = $direccion_destino_proveedor;
	}
	
	public function getOrigenPresupuesto() {
	    return $this->origenPresupuesto;
	}
	public function setOrigenPresupuesto($origenPresupuesto) {
	    $this->origenPresupuesto = $origenPresupuesto;
	}
	
	public function getMedioRecepcion() {
	    return $this->medioRecepcion;
	}
	public function setMedioRecepcion($medioRecepcion) {
	    $this->medioRecepcion = $medioRecepcion;
	}
	
	public function getItinierario() {
	    return $this->itinerario;
	}
	public function setItinierario($itinerario) {
	    $this->itinerario = $itinerario;
	}
	
	public function getFechaInicio() {
	    return $this->fechaInicio;
	}
	public function setFechaInicio($fechaInicio) {
	    $this->fechaInicio = $fechaInicio;
	}
	
	public function getHoraInicio() {
	    return $this->horaInicio;
	}
	public function setHoraInicio($horaInicio) {
	    $this->horaInicio = $horaInicio;
	}
	
	public static function esSqlServer(){
		return false;
	}

	public function setGpsSalida($gps){
		$this->gpsSalida = $gps;
	}	
	
	public function getGpsSalida(){
		return $this->gpsSalida;
	}
	
	public function getGpsRetorno() {
	    return $this->gpsRetorno;
	}
	public function setGpsRetorno($gpsRetorno) {
	    $this->gpsRetorno = $gpsRetorno;
	}
	
	public static function getMinimoPrecio($grupo){
		$db = self::getDb();
		$select = $db->select();
		$select->setIntegrityCheck(false);
		$select->from(array('pre'=>'PRECIOS'),array('precioMinimo'=>'PRECIOS_CON'));
		$select->where('cod_tarifa=?',self::TARIFA_DEFECTO_PRECIO);
		$select->where('cod_concepto=?',self::CONCEPTO_DEFECTO_PRECIO);
		$select->where('cod_grupo=?',$grupo);
		$resultado = $db->fetchRow($select);
		if ($resultado){
			$resultado = $resultado->toArray();
			return round($resultado['precioMinimo']/8,2);		
		} else { 
			return 0;
		}

	}

	public function getCodigoReserva() {
	    return $this->codigoReserva;
	}
	public function setCodigoReserva($codigoReserva) {
	    $this->codigoReserva = $codigoReserva;
	}

	public function getCodigoServicio() {
		return $this->codigoServicio;
	}
	public function setCodigoServicio($codigoServicio) {
		$this->codigoServicio = $codigoServicio;
	}
	
	public function getCodigoCliente() {
	    return $this->codigoCliente;
	}
	public function setCodigoCliente($codigoCliente) {
	    $this->codigoCliente = $codigoCliente;
	}
	
	public function getIntentoTpv() {
	    return $this->intentoTpv;
	}
	public function setIntentoTpv($intentoTpv) {
	    $this->intentoTpv = $intentoTpv;
	}
	
	public function getArchivoRuta() {
	    return $this->archivoRuta;
	}
	public function setArchivoRuta($archivoRuta) {
	    $this->archivoRuta = $archivoRuta;
	}
	
	public function getKmsRuta() {
	    return $this->kmsRuta;
	}
	public function setKmsRuta($kmsRuta) {
	    $this->kmsRuta = $kmsRuta;
	}
	
	public function getTiempoRuta() {
	    return $this->tiempoRuta;
	}
	public function setTiempoRuta($tiempoRuta) {
	    $this->tiempoRuta = $tiempoRuta;
	}
	
	public function getUsuarioKarve() {
	    return $this->usuarioKarve;
	}
	public function setUsuarioKarve($usuarioKarve) {
	    $this->usuarioKarve = $usuarioKarve;
	}

	public function getCodigoPresupuesto() {
	    return $this->numeroPresupuesto;
	}
	public function setCodigoPresupuesto($numeroPresupuesto) {
	    $this->numeroPresupuesto = $numeroPresupuesto;
	}
	
	
	
	/*
	public function calcularCierre($fechaFin, $horaFin, $kmServicioLlegada){
		$this->kilometrosVehiculoLlegada = $kmServicioLlegada;
		$this->fechaServicioFin = $fechaFin;
		$this->horaServicioFin = $horaFin;
		$this->insertaKmExtra($kmServicioLlegada);
		$this->insertarHorasExtra($fechaFin, $horaFin);
		$this->recalcularPrecio();

	}

	private function insertaKmExtra($kmServicioLlegada){
		// El concepto de servicio debe estar creado
		$linea = new ServicioLinea($this->numeroServicio, self::CON_LIN_EXTRA_KMS);
		//$this->limiteKilometros=0;
		if ($linea->id > 0){
			if ($this->limiteKilometros === 0 || $this->limiteKilometros > 0){
				$this->kilometrosVehiculoLlegada = $kmServicioLlegada;
				$this->kilometrosServicio = $this->kilometrosVehiculoLlegada - $this->kilometrosVehiculoSalida;
				$kmExtra = $this->kilometrosServicio - $this->limiteKilometros;
				if ($linea->id>0 && $kmExtra > 0){
					$linea->grupo = $this->vehiculoGrupo;
					$linea->tarifa = $this->tarifa;
					$linea->asignarCantidad($kmExtra);
					$linea->save();
				} elseif ($linea->id>0) {
					$linea->grupo = $this->vehiculoGrupo;
					$linea->tarifa = $this->tarifa;
					$linea->asignarCantidad(0);
					$linea->save();
				}
			}
		}
	}

	private function insertarHorasExtra($fechaFin, $horaFin){
		// El concepto de servicio debe estar creado
		$linea = new ServicioLinea($this->numeroServicio, self::CON_LIN_EXTRA_HORAS);
		if ($linea->id > 0) {
			if ($this->limiteHoras === 0 || $this->limiteHoras > 0) {
				$minutosCortesia = 15;
				$fechaFinMysql = AppHerramienta::fechaHumanaAMysql($fechaFin);
				$ff = strtotime($fechaFinMysql.' '.$horaFin);
				$fs = strtotime(AppHerramienta::fechaHumanaAMysql($this->fechaServicioInicio).' '.$this->horaServicioInicio);
				$fs = $fs + ($this->limiteHoras*60*60);
				$diferencia_ensegundos = $ff - $fs;
				$horas = floor( $diferencia_ensegundos / (60*60) );
				$minutos = ($diferencia_ensegundos - (60*60*$horas))/60;
				if ($minutos>$minutosCortesia)
					$horas +=1;
				if ($horas>0){
					$this->fechaServicioFin = $fechaFin;
					$this->horaServicioFin = $horaFin;
					$linea->grupo = $this->vehiculoGrupo;
					$linea->tarifa = $this->tarifa;
					$linea->asignarCantidad($horas);
					$linea->save();
				} else {
					$this->fechaServicioFin = date('d/m/Y',$fs);
					$this->horaServicioFin = date('H:i:j',$fs);
					$linea = new ServicioLinea($this->numeroServicio, self::CON_LIN_EXTRA_HORAS);
					$linea->grupo = $this->vehiculoGrupo;
					$linea->tarifa = $this->tarifa;
					$linea->asignarCantidad(0);
					$linea->save();
				}
			}
		}

	}

	protected function recalcularPrecio(){
		$lineas = $this->getLineas()->getDatos();
		$baseImponible = 0;
		$iva = 0;
		foreach ($lineas as $reg) {
			$baseImponible += $reg['subtotal'];
			$iva += $reg['subtotal']*($reg['iva']/100);
		}

		$subtotal = $baseImponible + $iva;
		$this->baseImponible = $baseImponible;
		$this->ivaTotal = $iva;
		$this->totalConIva = $subtotal;
	}


	public static function lst_mitrabajo($parametros) {
		$select = self::selectObjeto();
		if(isset($parametros['chofer']) && $parametros['chofer'])
			$select->where("a.CHOFER_CON1 = ?",$parametros['chofer']);
		$select->where("a.hechoconchofer_con1 is  null or a.hechoconchofer_con1 = 0");
		$usuario = Usuario::UsuarioLoqueado();
		$select->where("a.NUMERO like '".$usuario->EMPRESA."%'");

		$select->where("a.usuanula_con1 is  null");
		$select->where("CONTRATOS2.feanu_con2 is  null");
		$select->order(array("a.FSALIDA_CON1 desc", "a.HSALIDA_CON1 desc"));

		$resultado = self::selectExecute($select,$parametros);
		$datos = $resultado->getDatos();
		foreach ($datos as $key => $value){
			//$datos[$key]['fechaFormada'] = $value['numeroServicio'].'<br/>'.$value['fechaServicioInicio'].'<br/>'.substr($value['horaServicioInicio'], 0, 5);
			$datos[$key]['horaServicioInicio'] = substr($value['horaServicioInicio'], 0, 5);
			$datos[$key]['nombre_estado'] = self::getEstado($value);
				
			$origen = $value['origenLugar'];
			if (empty($origen))
				$origen = $value['origenPoblacion'].' '.$value['origenCalle'].' '.$value['origenNumero'];
			$datos[$key]['origen'] = substr($origen,0,20);
			$destino = $value['destinoLugar'];
			if (empty($destino))
				$destino = $value['destinoPoblacion'].' '.$value['destinoCalle'].' '.$value['destinoNumero'];
			$datos[$key]['destino'] = substr($destino,0,20);
			$datos[$key]['tipoServicio'] = substr($datos[$key]['tipoServicio'], 0,25);
				
		}
		$resultado->setDatos($datos);
		return $resultado;
	}
	*/
	/*public function save(){
		parent::save();
	//$this->saveParcking();
	}
	*/
	
	/*
	public function saveParcking(){
		$parking = ServicioLinea::getParkingByServicio($this->id);
		print_r($parking);
		die();

		if($parking instanceof ServicioLinea){
			$parking->cantidad = $this->cantidadParking;
			$parking->precio = $this->precioParking;
			$parking->save();
		}





	}

	public function getLineas(){
		return ServicioLinea::getByServicio($this->numeroServicio);
	}

	public function getEstados(){
		$salida = array();
		foreach (self::$asociado_estado as $key => $value){
			$valor = $this->$value;
			$llamada = new LlamadasEntrantes($valor);
			if($llamada->id)
				$salida[$key]= $llamada;
				
		}
		return $salida;

	}


	public function CambiarEstado($estado){

		$usuario = Usuario::UsuarioLoqueado();
		$gps = gps::getUltimaPosicionChofer();
		$ID_TELFENTRADA_LLEN = 32;
		$TELEFONO_ENTRADA_LLEN='APP3';
		$pasados = $this->getEstados();



		if(isset($pasados[$estado])){
			return;
		}


		switch ($estado) {
			case self::ST_CONFIRMAR:

				if($this->LLAMADA_CONFIRMA == null)
					$this->LLAMADA_CONFIRMA = -999;
				$this->ESTADO_SERVICIO = 1;

				$ID_TELFENTRADA_LLEN = '32';
				$TELEFONO_ENTRADA_LLEN='APP3';
				break;
			case self::ST_SALIDA_GARAGE:
				$ID_TELFENTRADA_LLEN = '30';
				$TELEFONO_ENTRADA_LLEN='APP1';
				break;
			case self::ST_EN_LUGAR_INICIO:
				if($this->LLAMADA_ENLUGAR == null)
					$this->LLAMADA_ENLUGAR = -999;
				$this->ESTADO_SERVICIO = 2;
				$ID_TELFENTRADA_LLEN = '33';
				$TELEFONO_ENTRADA_LLEN='APP4';
				break;
			case self::ST_CON_CLIENTE:
				if($this->LLAMADA_ENCOCHE == null)
					$this->LLAMADA_ENCOCHE = -999;
				$this->ESTADO_SERVICIO = 2;

				$ID_TELFENTRADA_LLEN = '34';
				$TELEFONO_ENTRADA_LLEN='APP5';
				break;
			case self::ST_FINALIZADO:
				if($this->LLAMADA_FINALIZADO == null)
					$this->LLAMADA_FINALIZADO = -999;
				$this->ESTADO_SERVICIO = 5;
				$ID_TELFENTRADA_LLEN = '35';
				$TELEFONO_ENTRADA_LLEN='APP6';
				break;
			case self::ST_EN_GARAGE:
				$ID_TELFENTRADA_LLEN = '31';
				$TELEFONO_ENTRADA_LLEN='APP2';
				break;
		}

		//$this->save();

		$llamadaEntrada = new LlamadasEntrantes();

		$llamadaEntrada->TELEFONO_LLEN = 'APP';
		$llamadaEntrada->ID_TELFENTRADA_LLEN = $ID_TELFENTRADA_LLEN;
		$llamadaEntrada->TELEFONO_ENTRADA_LLEN = $TELEFONO_ENTRADA_LLEN;
		$llamadaEntrada->SERVICIO = $this->id;
			

		$llamadaEntrada->save();

		$campo = self::$asociado_estado[$estado];
		$this->$campo = $llamadaEntrada->id;

		$this->save();

	}

	private static function getEstado($llamadas = array()){

		$estado = 'Pte confirmar';
		if ($llamadas['LLAMADA_CONFIRMA']>0) $estado = 'Pte_salir_garaje';
		else return $estado;

		if ($llamadas['LLAMADA_SGARAJE']>0) $estado = 'Pte_llegar_lugar';
		else return $estado;

		if ($llamadas['LLAMADA_ENLUGAR']>0) $estado = 'Pte_cliente';
		else return $estado;

		if ($llamadas['LLAMADA_ENCOCHE']>0) $estado = 'Pte_finalizar';
		else return $estado;

		if ($llamadas['LLAMADA_FINALIZADO']>0) $estado = 'Pte_llegar_garaje';
		else return $estado;

		if ($llamadas['LLAMADA_LGARAJE']>0) $estado = 'En_garaje';
		else return $estado;
		return $estado;
	}

	public function getCodigoParaViaje(){
		return 'PR'.substr($this->id, 2);
	}
*/


public function getVehiculoGrupo() {
    return $this->vehiculoGrupo;
}
public function setVehiculoGrupo($vehiculoGrupo) {
    $this->vehiculoGrupo = $vehiculoGrupo;
}

public function getContactoNombre() {
    return $this->contactoNombre;
}
public function setContactoNombre($nombreContacto) {
    $this->contactoNombre = $nombreContacto;
}

public function getContactoTelefono() {
    return $this->contactoTelefono;
}
public function setContactoTelefono($telefonoContacto) {
    $this->contactoTelefono = $telefonoContacto;
}

public function getClienteTelefono() {
    return $this->telefonoCliente;
}
public function setClienteTelefono($telefonoCliente) {
    $this->telefonoCliente = $telefonoCliente;
}

public function getPrecioConIva() {
    return $this->totalConIva;
}
public function setPrecioConIva($totalConIva) {
    $this->totalConIva = $totalConIva;
}

		


}